#include <stdio.h>
#include <stdlib.h>
#include <time.h> // See Appendix A

void fill_array(int *a, int n);
int sum_array(int *a, int n);
void wrt_array(int *a, int n);

int main(void){
	int *a, n;
	srand(time(NULL)); // Seeds the random number generator

	for( ; ; ){
		printf("Input the number of elements in the array (0 to exit): \n");
		if(scanf("%d", &n) != 1 || n<1) 
			break;
		putchar('\n');
		a=malloc(n*sizeof(int));	// try also a=calloc(n,sizeof(int));
		fill_array(a,n);
		wrt_array(a,n);
		printf("sum = %d\n\n", sum_array(a,n));
		free(a);
	}
	printf("Bye!\n\n");
	return 0;
}

void fill_array(int *a, int n){
	int i;
	for(i=0; i<n; ++i)
		a[i]=rand() % 19 - 9;
}

int sum_array(int *a, int n){
	int i, sum=0;
	for(i=0; i<n; ++i)
		sum += a[i];
	return sum;
}

void wrt_array(int *a, int n){
	int i;
	printf("a=[");
	for(i=0; i<n; ++i)
		printf("%d%s", a[i], ((i<n-1) ? ", " : "]\n"));
}

// gcc es15_calloc.c -o es15_calloc
// ./es15_calloc

